unit ServerAddDlg;

interface

uses
  Serverdata,
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Graphics, FMX.Controls, FMX.Forms, FMX.Dialogs, FMX.StdCtrls,
  CoreDlg, FMX.ListBox, FMX.Layouts, FMX.Objects, FMX.Menus, FMX.Edit,
  FMX.TabControl, FMX.Controls.Presentation, FMX.MultiView;

type
  TAddServerForm = class(TCoreForm)
    Label1: TLabel;
    eServerName: TEdit;
    Label2: TLabel;
    eServerURL: TEdit;
    PopupServerAdd: TPopupMenu;
    MenuServerAddOk: TMenuItem;
    MenuServerAddCancel: TMenuItem;
    MenuServerAddClear: TMenuItem;
    MenuServerAddGet: TMenuItem;
    VertScrollBox1: TVertScrollBox;
    Layout1: TLayout;
    Label6: TLabel;
    eProxy: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure MenuServerAddOkClick(Sender: TObject);
    procedure MenuServerAddClearClick(Sender: TObject);
    procedure MenuServerAddCancelClick(Sender: TObject);
    procedure MenuServerAddGetClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    //fFormMoveManager:  TKeyboardFormManager;
    fModeAdd    : boolean;
    fSelServerItem : TServerItem;
    procedure SetServerData(SItem: TServerItem);
  public
    fEditServerItem: TServerItem;
    procedure AddServer(SelServerItem : TServerItem);
    procedure EditServer(ServerItem: TServerItem);
  end;

var
  AddServerForm: TAddServerForm;

implementation

{$R *.fmx}

procedure TAddServerForm.FormCreate(Sender: TObject);
begin
  inherited;
  fModeAdd := true;
  AddPopup('Add Server',PopupServerAdd);
  fSelServerItem  := nil;
  fEditServerItem := nil;
  //fFormMoveManager := TKeyboardFormManager.create(self,VertScrollBox1,Layout1);
end;

procedure TAddServerForm.FormDestroy(Sender: TObject);
begin
  inherited;
  //fFormMoveManager.DisposeOf;
end;


procedure TAddServerForm.AddServer(SelServerItem: TServerItem);
begin
   fModeAdd := true;
   fSelServerItem := SelServerItem;
   fEditServerItem := nil;
   MenuServerAddClearClick(self);
end;

procedure TAddServerForm.EditServer(ServerItem: TServerItem);
begin
  fModeAdd := false;
  fSelServerItem  := nil;
  fEditServerItem := ServerItem;
  SetServerData(fEditServerItem);
end;

procedure TAddServerForm.SetServerData(SItem : TServerItem);
begin
  if SItem <> nil then
  begin
    eServerName.Text := Sitem.Server.Caption;
    eServerURL.Text  := Sitem.Server.ServerName;
    eProxy.Text      := Sitem.Server.Proxy;
  end
end;


procedure TAddServerForm.MenuServerAddCancelClick(Sender: TObject);
begin
  BackToParentForm;
end;

procedure TAddServerForm.MenuServerAddClearClick(Sender: TObject);
begin
  eServerName.Text := '';
  eServerURL.Text := '';
  eProxy.Text := '';
end;


procedure TAddServerForm.MenuServerAddGetClick(Sender: TObject);
begin
  if fSelServerItem <> nil then
    SetServerData(fSelServerItem)
  else
   if fEditServerItem <> nil then
    SetServerData(fEditServerItem)
end;

procedure TAddServerForm.MenuServerAddOkClick(Sender: TObject);
begin
  if (trim(eServerName.Text) = '') or (trim(eServerURL.Text) = '') then
  begin
    ShowMessage('server name or server url empty!');
    exit;
  end;
  BackToParentForm(true);
end;

end.
